package com.simuwang.base.pojo.dos;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.simuwang.base.common.util.DateUtils;
import com.simuwang.base.pojo.vo.FileManageVO;
import lombok.Data;

import java.util.Date;

/**
 * FileName: FileManageDO
 * Author:   chenjianhua
 * Date:     2024/12/18 17:01
 * Description: ${DESCRIPTION}
 */
@Data
@TableName("file_manage")
public class FileManageDO {
    /**
     * ID
     */
    @TableId(value = "id",type = IdType.AUTO)
    private Integer id;
    /**
     * 文件ID
     */
    @TableField(value = "file_id")
    private Long fileId;
    /**
     *  文件名称
     */
    @TableField(value = "file_name")
    private String fileName;
    /**
     *  文件路径
     */
    @TableField(value = "file_path")
    private String filePath;
    /**
     *  基金ID
     */
    @TableField(value = "fund_id")
    private String fundId;
    /**
     *  基金名称
     */
    @TableField(value = "fund_name")
    private String fundName;
    /**
     *  备案编码
     */
    @TableField(value = "register_number")
    private String registerNumber;
    /**
     * 公司ID
     */
    @TableField(exist = false)
    private String companyId;
    /**
     * 公司名称
     */
    @TableField(exist = false)
    private String companyName;
    /**
     *  文件日期
     */
    @TableField(value = "file_date")
    private Date fileDate;
    /**
     *  文件类别，1-净值规模，2-估值表，3-月度报告，4-季度报告，5-年度报告，6-基金合同，7分红公告，8-变更过公告
     */
    @TableField(value = "file_type")
    private Integer fileType;
    /**
     * 分类来源,0-系统分类，1-人工分类
     */
    @TableField(value = "source_type")
    private Integer sourceType;
    /**
     * 创建时间
     */
    @TableField(value = "createtime")
    private Date createTime;
    /**
     *  修改时间
     */
    @TableField(value = "updatetime")
    private Date updateTime;
    /**
     *  创建人ID
     */
    @TableField(value = "creatorid")
    private Integer creatorId;
    /**
     *  修改人ID
     */
    @TableField(value = "updaterid")
    private Integer updaterId;
    /**
     *  有效标识，1-有效，0-无效
     */
    @TableField(value = "isvalid")
    private Integer isvalid;

    public FileManageVO toVO() {
        FileManageVO vo = new FileManageVO();
        vo.setId(id);
        vo.setFileId(fileId);
        vo.setFilePath(filePath);
        vo.setFileName(fileName);
        vo.setCompanyName(companyName);
        vo.setCompanyId(companyId);
        vo.setFileDate(DateUtils.format(fileDate,DateUtils.YYYY_MM_DD));
        vo.setFundId(fundId);
        vo.setFundName(fundName);
        vo.setFileType(fileType);
        vo.setSourceType(sourceType);
        vo.setRegisterNumber(registerNumber);
        return vo;
    }
}
